package org.jeecg.modules.cabinet.controller;

import java.util.Arrays;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.cabinet.entity.Cabinet;
import org.jeecg.modules.cabinet.service.ICabinetService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 智能工具柜
 * @Author: jeecg-boot
 * @Date:   2025-01-15
 * @Version: V1.0
 */
@Api(tags="智能工具柜")
@RestController
@RequestMapping("/toolbox/cabinet")
@Slf4j
public class CabinetController extends JeecgController<Cabinet, ICabinetService> {
	@Autowired
	private ICabinetService cabinetService;

	/**
	 * 分页列表查询
	 *
	 * @param cabinet
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "智能工具柜-分页列表查询")
	@ApiOperation(value="智能工具柜-分页列表查询", notes="智能工具柜-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Cabinet>> queryPageList(Cabinet cabinet,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Cabinet> queryWrapper = QueryGenerator.initQueryWrapper(cabinet, req.getParameterMap());
		Page<Cabinet> page = new Page<Cabinet>(pageNo, pageSize);
		IPage<Cabinet> pageList = cabinetService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param cabinet
	 * @return
	 */
	@AutoLog(value = "智能工具柜-添加")
	@ApiOperation(value="智能工具柜-添加", notes="智能工具柜-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_cabinet:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Cabinet cabinet) {
		cabinetService.save(cabinet);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param cabinet
	 * @return
	 */
	@AutoLog(value = "智能工具柜-编辑")
	@ApiOperation(value="智能工具柜-编辑", notes="智能工具柜-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_cabinet:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Cabinet cabinet) {
		cabinetService.updateById(cabinet);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "智能工具柜-通过id删除")
	@ApiOperation(value="智能工具柜-通过id删除", notes="智能工具柜-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_cabinet:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		cabinetService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "智能工具柜-批量删除")
	@ApiOperation(value="智能工具柜-批量删除", notes="智能工具柜-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_cabinet:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.cabinetService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "智能工具柜-通过id查询")
	@ApiOperation(value="智能工具柜-通过id查询", notes="智能工具柜-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Cabinet> queryById(@RequestParam(name="id",required=true) String id) {
		Cabinet cabinet = cabinetService.getById(id);
		if(cabinet==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(cabinet);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param cabinet
    */
    //@RequiresPermissions("org.jeecg.modules:bu_cabinet:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Cabinet cabinet) {
        return super.exportXls(request, cabinet, Cabinet.class, "智能工具柜");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_cabinet:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Cabinet.class);
    }

	 /**
	  *  同步信息
	  *
	  * @param cabinet
	  * @return
	  */
	 @AutoLog(value = "智能工具柜-同步")
	 @ApiOperation(value="智能工具柜-同步", notes="智能工具柜-同步")
	 //@RequiresPermissions("org.jeecg.modules:bu_cabinet:edit")
	 @RequestMapping(value = "/sync", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> sync(@RequestBody Cabinet cabinet) {
//		 cabinetService.updateById(cabinet);
		 cabinetService.sync(cabinet);
		 return Result.OK("编辑成功!");
	 }

}
